#include <iomanip>
#include <iostream>
#include <sstream>
#include <string>

#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

std::ostringstream out;

void
flushout()
{
  std::string output(out.str());
  write(1, output.data(), output.size());
}

int
main()
{
  std::atexit(flushout);
  out << "About to call fork" << std::endl;

  pid_t pid = fork();
  if (pid == 0) {
    std::cout << "Hello from the child" << std::endl;
    exit(0);
  }

  int status;
  waitpid(pid, &status, 0);
  out << "pid " << pid << " status 0x" << std::hex << status << std::endl;
}
